import random


def input_choice(question: str, choices: list[str]) -> str:
    print(question + ' [' + ' | '.join(choices) + ']')
    while True:
        s = input('> ')
        if s in choices:
            return s
        print('Invalid answer. Try again.')


def shape(word: str, guesses: str) -> str:
    s = ''
    for c in word:
        if c in guesses:
            s += c
        else:
            s += '_'
    return s


def hangman(word: str, max_fails: int):
    guesses = ""
    fails = 0
    while fails <= max_fails:
        s = shape(word, guesses)
        if "_" not in s:
            break
        guess = input(s + "; " + str(max_fails - fails) + " mistakes left; make a guess: ")
        if len(guess) != 1:
            print("Invalid input. Guess has to be exactly one letter.")
        elif guess not in word:
            fails += 1
        else:
            guesses += guess
    if fails < max_fails:
        print("\nYou won! The word was '" + word + "'! You're the best! Everyone loves you!")
    else:
        print("\nYou lost... The word was '" + word + "'... How did you not get that?!")


if __name__ == '__main__':
    words = ['apple', 'tree', 'python', 'bench', 'float']

    max_fails = int(input("Number of allowed mistakes: "))

    while input_choice("\nWanna play a game?", ['yes', 'no']) == 'yes':
        word = random.choice(words)
        hangman(word, max_fails)
